package de.hhu.ba.yoshikoWrapper.core;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.ResourceBundle;

public class LocalizationManager {
	//Locales
	static public final Locale usEnglish = new Locale("en","US");
	static public final Locale german = new Locale("de","DE");
	//List of Locales
	static public final ArrayList<Locale> locales = new ArrayList<Locale>(
			Arrays.asList(
					usEnglish,
					german
		)
	);
	
	static private ResourceBundle currentBundle;
	
	static public Locale currentLanguage = usEnglish;
	
	static public ResourceBundle yoshikoStrings() {
		if (currentBundle == null) {
			currentBundle = ResourceBundle.getBundle("YoshikoStrings",currentLanguage);
		}
		return currentBundle;
	}
	
	static public void switchLanguage(Locale lcl) {
		currentLanguage = lcl;
		currentBundle = ResourceBundle.getBundle("YoshikoStrings",currentLanguage);
	}
}
